QGIS Application - Feature request #2315
QGIS exceptions does not support unicode
2009-12-23 02:48 AM - marisn -

Status: Closed

Priority: Low

Assignee: Jirgen Fischer

Category: Translations and international

Pull Request or Patch supplied: Resolution: fixed
Easy fix?: No Copied to github as #: 12375
Description

Current exception handling in QGIS can not display correctly non-ascii error messages. Still there is a code, that migh emit exception with
unicode text as it's content. Currently such text is displayed as ascii string (non-ascii chars are grabbled). Such issue could be solved, if
exception text would be stored as a QString, still as | have no skills in C++ and Qt, | can't provide patches :(

Example: https://trac.osgeo.org/qgis/browser/trunk/qgis/src/core/ggscoordinatetransform.cpp?rev=12550#L473

Associated revisions

Revision d2d9cf9a - 2009-12-28 10:33 PM - Jiirgen Fischer

fix #2315

git-svn-id: http://svn.osgeo.org/qgis/trunk/qgis@12640 ¢8812cc2-4d05-0410-92ff-de0c093fc19¢c

Revision a13c99d1 - 2009-12-28 10:33 PM - Jiirgen Fischer

fix #2315

git-svn-id: http://svn.osgeo.org/qgis/trunk@12640 c8812cc2-4d05-0410-92ff-de0c093fc19c

History

#1 - 2009-12-23 04:22 AM - Jiirgen Fischer

The exception can handle non-ascii messages.

I've already had a pending patch - which also contains string changes, we can't currently commit. Although | wasn't able to get a garbled error message
as my proj doesn't emit localized messages. | just see the latvian error message with an English error text from proj.

#2 - 2009-12-24 04:09 AM - marisn -

Changing bug description back to original, as proj.4 currently does not support localized error messages. This is (almost) pure QGIS issue.

Compiled current QGIS trunk (commit:b2e7a7c1 (SVN r12613)) without any CMAKE_BUILD_TYPE setting with Qt 4.6.0. QGIS displays pop-up with text
and after clicking OK, it's impossible to close QGIS window (only with xkill):

NeveiksmA«gs forward transformA[R ana no

(10075.3, 112109)
ar kAv4A«du: latitude or longitude exceeded limits
https://trac.osgeo.org/qgis/browser/trunk/qgis/src/core/qgscoordinatetransform.cpp?rev=12550#L473
String should read (still it's grammatically incorrect due to how this string is represented to translators and hardcoded "forward" word):

Neveiksmigs forward transformésana ...

IMHO problem lies here: http://trac.osgeo.org/qgis/browser/trunk/qgis/src/core/qgsexception.h#L.54

Conversion between QString and std::string is done via fromAscii() (if | understood QString manual correctly).

#3 - 2009-12-24 08:14 AM - Jiirgen Fischer

commit:ed0d9dad (SVN r12616) should catch the exceptions in the first place (the V2 renderers would hang otherwise),
commit:8cc3c65e (SVN r12617) should fix the encoding problem, if they still become visible somewhere,
but the translation string update is still pending.

#4 - 2009-12-28 01:33 PM - Jiirgen Fischer
- Resolution set to fixed

- Status changed from Open to Closed

applied in commit:a13c99d1 (SVN r12641).

Files

qggscoordinatetransform_exception_message.patch 1.81 KB 2009-12-23 marisn -
qgis_forward_encoding1.png 205 KB 2009-12-24 marisn -
ggscoordtransform.patch 414 KB 2009-12-24 marisn -
pjerr.diff 3.71 KB 2009-12-24 Jurgen Fischer
